---
title: XRInputSourcesChangeEvent.added
slug: Web/API/XRInputSourcesChangeEvent/added
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Mixed
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - XR
  - XRInputSource
  - XRInputSourcesChangeEvent
  - augmented
---
<p>{{APIRef("WebXR Device API")}} {{SecureContext_Header}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRInputSourcesChangeEvent")}} property {{domxref("XRInputSourcesChangeEvent.added", "added")}} is a list of zero or more input sources, each identified using an {{domxref("XRInputSource")}} object, which have been newly made available for use.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>addedInputs</em> = <em>xrInputSourcesChangeEvent</em>.added;</pre>

<h3 id="Value">Value</h3>

<p>An {{jsxref("Array")}} of zero or more {{domxref("XRInputSource")}} objects, each representing one input device added to the XR system.</p>

<h2 id="Examples">Examples</h2>

<p>The example below creates a handler for the {{domxref("XRSession.inputsourceschange_event", "inputsourceschange")}} event that processes the lists of added and removed from the WebXR system. It looks for new and removed devices whose {{domxref("XRInputSource.targetRayMode", "targetRayMode")}} is <code>tracked-pointer</code>.</p>

<pre class="brush: js">xrSession.oninputsourcescchange = event =&gt; {
  for (let input of event.added) {
    if (input.targetRayMode == "tracked-pointer") {
      addedPointerDevice(input);
    }
  }
  for (let input of event.removed) {
    if (input.targetRayMode == "tracked-pointer") {
      removedPointerDevice(input);
    }
  }
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrinputsourceschangeevent-added","XRInputSourcesChangeEvent.added")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRInputSourcesChangeEvent.added")}}</div>
